#!/usr/bin/perl -wT
#
# The diary cgi script for functionality with headline.
# Copyright (C) 2003 Robert Sim, Scott Burlington

#This program is free software; you can redist ibute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
#  ChangeLog: $Revision: 1.2 $
#
#  $Log: diary.cgi,v $
#  Revision 1.2  2003/04/21 19:13:15  simra
#  No changes, just figured out how to keep diary synced, by keeping the cgi in
#  my public_html and symlinking to it from ~simra/work/headline/ I was afraid
#  that CVS wouldn't follow the symlink, but surprise surprise it does..
#
#  Revision 1.1  2003/04/21 18:49:11  simra
#  Added the diary.cgi script.  Any ideas how to keep this one synced with the
#  one in my public_html?
#
#  Also made some cool additions to the diary functionality, so one can add a
#  read-more part, like slashdot's longer book reviews, etc.  See my home page
#  for an example.  Of course, it's only useful if you have extra content to
#  add.. :-)
#
#
#
#
#

require 5;
use strict;
require "./cgi-bin/cgi-lib.pl";
use CGI::Cookie;

#my $home="/home/robbo";
my $home="/home/discovery/simra";
my $ddir = "$home/.diary2";
$ENV{'PATH'}='';

my $DiaryHeadFont=qq(<FONT face="arial,helvetica" size=3 color="#FFFFFF">);
my $DiaryBodyFont="";
my $username=$home;
$username=~s/.*\/(.*)/$1/;
my $authenticated=0;
my $cookieerror="";

 MAIN: 
{
  my (%input);  # The CGI data

  # Read in all the variables set by the form
  if (&ReadParse(\%input) && ! ($input{'command'} eq 'Login')) {
    print &authenticate(\%input);
    &ProcessForm(\%input);
  } else {
    print &authenticate(\%input);
    &PrintBasicForm;
  }
}


sub MyHTMLTop {
  my $title=shift;
  return <<ENDHEADER;
<html>
<head>
<link rel="stylesheet" href="http://www.cim.mcgill.ca/~simra/style.css" type="text/css">
<title>$title</title>
</head>
<body>
<div class="header">
<table width="100%">
<tr><td valign=bottom align=left>
<H1>simra's weblog</h1>
<a href="index.html">home</a> <a href="contact.html">contact</a> <a href="research.html">publications</a> <a href="cv.html">cv</a> <a href="software.html">software</a> 
<td valign=bottom align=right>
<a href="koan.html">koan</a>
<a href="http://www.simra.net">simra.net</a>
</td></tr>
</table>
</div>
<div class="core">
ENDHEADER
}

sub PrintBasicForm {
  print &PrintHeader;
  print &MyHTMLTop("Simra's Weblog");

  my %entries=LoadDiaryEntries();

  my @entry_keys=reverse sort { $a <=> $b }  keys %entries;

  print_search_form("");
  print_login_form() unless $authenticated;
#  print "Cookie error: $cookieerror<br>" unless $authenticated;
#  print "<a href=\"/~${username}/\">Home</a><br>\n";
  print "<ul>\n";
  foreach my $key ( reverse sort { $a <=> $b }  keys %entries) {
    my $entry=$entries{$key};
    print_entry_link($entry,$key);
  }
  print "</ul><P></div>\n";

print <<ENDSCRIPT;
<font size=1><script language="javascript"><!-- 
n=navigator.appName; a=document; function tt(){a.write("<img src=\\"counter/google_count.cgi?_id=simra\&_r="+r+"&_c="+c+"&_ref="+escape(a.referrer)+"&_loc="+escape(a.location)+"\\" height=0 ",
"width=0 border=0>");}//--></script><script language="javascript1.2"><!-- 
b=screen; r=b.width; n!="Netscape"?c=b.colorDepth : c=b.pixelDepth;//--></script>
<script language="javascript"><!-- 
tt(); //--></script><noscript><img src="counter/google_count.cgi?_id=simra" 
width=0 height=0 border=0 alt=""></font>
ENDSCRIPT

  print &HtmlBot;
}

sub print_search_form {
  my $script=&MyBaseUrl;
  my $arg=shift;
  my $newbutton=$authenticated?qq(<INPUT type=submit name="command" VALUE="New">):"";
  print <<ENDFORM;
<p>
<div class="searchform">
<form method=GET action="$script">
<INPUT type=text name=query maxlength=256 value="$arg">
<INPUT type=submit name="command" VALUE="Search"> 
$newbutton
</form>
</div>
<p>
ENDFORM
}

sub ProcessForm {
  my ($inref) = shift; # $inref is a reference to %input

  # Print the header
  print &PrintHeader;
  print &MyHTMLTop ("Simra's Weblog");

  my $query="";
  $query=$inref->{'query'} if defined $inref->{'query'};
  &print_search_form($query);
  print_login_form() unless $authenticated;
  # If you want, just print out a list of all of the variables.
  if (!defined $inref->{'command'} && defined $inref->{'id'}) {
    &print_entry($inref->{'id'});
  } elsif (defined $inref->{'command'}) {
    my $command=$inref->{'command'};

    if ($command eq 'Search') {

#      print "<a href=\"/~simra/\">Home</a><p>\n";
      print "<h3>Search results..</h3>\n";
      &search_entries($query);

    } elsif ($command eq 'Edit') {

      CgiDie("ID must be defined.") if (!defined $inref->{'id'});
      &print_edit_form($inref->{'id'});

    } elsif ($command eq 'New') {

      &print_new_form($inref->{'id'});

    } elsif ($command eq 'Save') {

      CgiDie("ID subject and body must be defined.") 
	if (!defined $inref->{'id'} ||
	    !defined $inref->{'body'} ||
	    !defined $inref->{'subject'});
      &save_form($inref->{'id'}, $inref->{'subject'}, $inref->{'body'}, $inref->{'xtra'});
      &print_entry($inref->{'id'});

    }
  }

#  print "<HR>And here is a list of the variables you entered...<P>";
#  print &PrintVariables($inref);

  # Close the document cleanly.
print <<ENDSCRIPT;
<font size=1><script language="javascript"><!-- 
n=navigator.appName; a=document; function tt(){a.write("<img src=\\"counter/google_count.cgi?_id=simra\&_r="+r+"&_c="+c+"&_ref="+escape(a.referrer)+"&_loc="+escape(a.location)+"\\" height=0 ",
"width=0 border=0>");}//--></script><script language="javascript1.2"><!-- 
b=screen; r=b.width; n!="Netscape"?c=b.colorDepth : c=b.pixelDepth;//--></script>
<script language="javascript"><!-- 
tt(); //--></script><noscript><img src="counter/google_count.cgi?_id=simra" 
width=0 height=0 border=0 alt=""></font>
ENDSCRIPT
  print &HtmlBot;

}


sub LoadDiaryEntries {
  opendir DDIR, $ddir or die "Can't open $ddir";
  my @ddir_entries=readdir DDIR;
  closedir DDIR;
  my (%entries, $l);
  for my $de (@ddir_entries) {
    next if ($de=~/\D/);
    open DF, "$ddir/$de" or die "Can't open $de";
    
    while ($l = <DF>) {
      if ($l =~ /^\<ENTRY/) {
	my ($etime)=$l=~/^<ENTRY\s+time=(.*)\s?>/;
	my $rec={};
	$entries{$etime}=$rec;
	$rec->{'body'}="";
	$rec->{'time'}=$etime;
	$l=<DF>;
	if ($l=~/^\<SUBJECT>/) {
	  ($rec->{'subject'}) = $l=~/^<SUBJECT>(.*)<\/SUBJECT>/;
	  $l=<DF>;
	} else {
	  $rec->{'subject'}="No Subject..";
	}
	while (defined $l && !($l eq "</ENTRY>\n")) {
	  $rec->{'body'}.=$l;
	  $l=<DF>;
	}
	$rec->{'xtra'}="";
	$l=<DF>;
	if (defined $l && $l=~/\<XTRA/) {
	  $l=<DF>;
	  while (defined $l && !($l eq "</XTRA>\n")) {
	    $rec->{'xtra'}.=$l;
	    $l=<DF>;
	  }
	}
      }
    }
  }
  return %entries;
}



sub make_date_string {
    my $time=shift;
    my @ltime=localtime($time);
    my $month=('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug',
	       'Sept','Oct','Nov','Dec')[$ltime[4]];
    my $weekday=('Sun','Mon','Tues','Wed','Thurs','Fri',
		 'Sat')[$ltime[6]];
    my $minute=sprintf "%02d", $ltime[1];
    my $year=$ltime[5]+1900;
    my $date_string="$weekday, $month $ltime[3], $year $ltime[2]:$minute";
    $date_string;
  }


sub print_entry {
  my $script=&MyBaseUrl;
  my $id=shift;
  my %entries=&LoadDiaryEntries();
  CgiDie("Entry $id undefined") if (! defined $entries{$id});
  my $entry=$entries{$id};
  my $date_string=make_date_string($entry->{'time'});
  my ($idx, $id_idx);
  my @entry_keys=reverse sort keys %entries;
  for ($idx=0; $idx<=$#entry_keys; $idx++) {
    $id_idx=$idx if ($entry_keys[$idx] eq $id);
  }
  my $prev=$entry_keys[$id_idx-1] if $id_idx>0;
  my $next=$entry_keys[$id_idx+1] if $id_idx<$#entry_keys;
  my $index_str="";
  $index_str.="<a href=\"$script?id=$prev\">Prev</a> " if $id_idx>0;
  $index_str.="<a href=\"$script?id=$next\">Next</a> " if $id_idx<$#entry_keys;
  $index_str.="<a href=\"$script\">Up</a>\n";
#  $index_str.="<a href=\"/~${username}/\">Home</a>";
  my $editbutton=$authenticated?qq(<INPUT type=submit name="command" VALUE="Edit">):"";
  print <<ENDENTRY;
$index_str<p>
<div class="diarytable">
<div class="diaryentry">
      <div class="diaryheader">
         <span class="diarysubject">$entry->{'subject'}</span>
         <span class="diarydate">$date_string</span>
      </div>
      <div class="diarybody">$entry->{'body'}
      </div>
ENDENTRY

  if (defined $entry->{'xtra'} && $entry->{'xtra'}=~/\S/) {
    print <<ENDXTRA;
<hr>
<div class="diarybody">$entry->{'xtra'}
</div>
ENDXTRA
  }
  print <<ENDENTRY2;
</div>
</div>
<form method=GET action="$script">
$editbutton
<INPUT type=hidden name="id" value="$id">
</form>
ENDENTRY2

#<TABLE width=100% border=0 cellpadding=0 cellspacing=0>
#<TR bgcolor="#000000" border=0 cellspacing=0>
#<TD valign=top align=left width="66%"><img src="http://www.cim.mcgill.ca/~simra/images/gradient.png" alt="" width=20 height=15 > $DiaryHeadFont <B>$entry->{'subject'}</B></FONT></TD>
#<TD align=right> $DiaryHeadFont 
#<B>$date_string</B></font></TD>
#</TR>
#<TR>\n<TD colspan=2> $DiaryBodyFont $entry->{'body'}
#</FONT></TD>
#</TR>
#</TABLE>

}

sub print_new_form {
  print_edit_form();
}

sub print_edit_form {
  if ($authenticated) {
    my $script=&MyBaseUrl;
    my $id=shift;
    my $entry;
    if (defined $id) {
      my %entries=&LoadDiaryEntries();
      CgiDie("Entry $id undefined") if (! defined $entries{$id});
      $entry=$entries{$id};
    } else {
      my $dtime=time();
      $entry={};
      $entry->{'time'}=$dtime;
      $id=$dtime;
    }
    my $date_string=make_date_string($entry->{'time'});
    my $index_str="";
    $index_str.="<a href=\"$script\">Up</a>\n";
#    $index_str.="<a href=\"/~${username}/\">Home</a>";
    my $body_text="";
    $body_text=$entry->{'body'} if (defined $entry->{'body'});
    my $xtra_text="";
    $xtra_text=$entry->{'xtra'} if (defined $entry->{'xtra'});
    my $subject_text="";
    $subject_text=$entry->{'subject'} if (defined $entry->{'subject'});
    print <<ENDENTRY;
$index_str<p>
<form method=POST action="$script">
<div class="diarytable">
<div class="diaryentry">
      <div class="diaryheader">
         <span class="diarysubject">
<INPUT type=text size="40" name=subject maxlength=256 value="$subject_text">
</span>
         <span class="diarydate">$date_string</span>
      </div>
      <div class="diarybody">
<TEXTAREA name=body rows="20" cols="80">$body_text</TEXTAREA>
      </div>
Read More:
      <div class="diarybody">
<TEXTAREA name=xtra rows="20" cols="80">$xtra_text</TEXTAREA>
      </div>

</div>
</div>
<INPUT type=submit name="command" value="Save">
<INPUT type=hidden name="id" value="$id">
</form>
ENDENTRY
  } else {
    my $id=shift;
    &print_entry($id);
  }
}

sub print_entry_link {
  my $script=&MyBaseUrl;
  my $entry=shift;
  my $key=shift;
  my $date_string=make_date_string($entry->{'time'});
  my $body=$entry->{'body'};
  $body=~s/\n/ /g;
  $body=~s/<.*?>/ /g;
  my @bd_words=split /\s+/, $body;
  print STDERR $entry->{'time'},": ";
  my $max_words=10;
  $max_words=$#bd_words if ($#bd_words<10);
  my $link_body=join ' ', @bd_words[0..$max_words];
  print <<ENDENTRY;
<li class="core"> <B><a href="$script?id=$key">$entry->{'subject'}</a></B> (<B>$date_string</B>)<br>
$link_body...<br>
ENDENTRY
}
  
sub search_entries {
  my $script=&MyBaseUrl;
  my $query=shift;
  my %entries=&LoadDiaryEntries();
  my @tokens=split /\s+/, $query;
  my $key;
#  print "Searching for @tokens ($query)<br>\n";
  foreach $key (keys %entries) {
    my $body=$entries{$key}->{'body'};
    $body=~s/\n/ /g;
    $body=~s/<.*?>/ /g;
    my $token;
    foreach $token (@tokens) {
      # Exact matches.  Score 0.5 here and then again another 0.5 below.
      my @result=$body=~/\b$token\b/gi;
      $entries{$key}->{'score'}+=0.5*($#result+1);
      @result=$entries{$key}->{'subject'}=~/$token/gi;
      $entries{$key}->{'score'}+=0.5*($#result+1);
      @result=make_date_string($entries{$key}->{'time'})=~/$token/gi;
      $entries{$key}->{'score'}+=0.5*($#result+1);

      # Substrings
      @result=$body=~/$token/gi;
      $entries{$key}->{'score'}+=0.5*($#result+1);
      @result=$entries{$key}->{'subject'}=~/$token/gi;
      $entries{$key}->{'score'}+=0.5*($#result+1);
      @result=make_date_string($entries{$key}->{'time'})=~/$token/gi;
      $entries{$key}->{'score'}+=0.5*($#result+1);
    }
  }
  foreach $key (reverse sort { $entries{$a}->{'score'} <=> $entries{$b}->{'score'} } keys %entries) {
    if ($entries{$key}->{'score'}>0) {
      print_entry_link($entries{$key},$key);
      print "Score: $entries{$key}->{'score'}\n";
    }
  }
}


sub save_form {
  if ($authenticated) {
    my $script=&MyBaseUrl;
    my $id=shift;
    my $subject=shift;
    my $body=shift;
    my $xtra=shift;
    if ($id=~/(\d+)/) {
      $id=$1;
    } else {
      CgiDie("ID $id undefined");
    }
    #  CgiDie("ID $id undefined")  if (! -e "$ddir/$id");
    `/bin/cp $ddir/$id $ddir/$id.bak`   if (-e "$ddir/$id");
    open ENTRY, ">$ddir/$id" or CgiDie("Can't open entry file $ddir/$id");
    print ENTRY "<ENTRY time=$id>\n";
    print ENTRY "<SUBJECT>$subject</SUBJECT>\n";
    $body=~s/\n\<ENTRY/\n \<ENTRY/gi;
    print ENTRY $body;
    print ENTRY "\n" unless $body=~/\n$/;
    print ENTRY "</ENTRY>\n";
    if (defined $xtra && $xtra=~/\S/) {
      print ENTRY "<XTRA>\n";
      print ENTRY $xtra;
      print ENTRY "\n" unless $xtra=~/\n$/;
      print ENTRY "</XTRA>\n";
    }
    close ENTRY;
    #  `$home/work/headline/headline`;
  } else {
    print "<H1>Not authenticated</h1>\n";
    print "<p>Sorry, no-can-do.\n";
    print &HtmlBot;
    exit;
  }
}


sub authenticate {
  my ($inref) = shift; # $inref is a reference to %input
  my %cookies = fetch CGI::Cookie;
  my ($user, $pass,$crypted);
  if ($cookies{'AUTH'}) {
    ($user,$pass) = split /:/, $cookies{'AUTH'}->value;
    $crypted=1;
  } else {
    $user=$inref->{'username'};
    $pass=$inref->{'password'};
    $crypted=0;
  }
  my $passfile="/home/discovery/simra/.htpasswd.diary";
  my @plines=`/bin/cat $passfile`;
  my ($auser,$apasswd)=split/:/, $plines[0];
  chomp $apasswd;
  my $cookieinfo="Set-Cookie: ";
  if ($user && $pass && $auser && $apasswd &&
      ($user eq $auser)) {
    if (($crypted && ($pass eq $apasswd)) ||
	(!$crypted && (crypt($pass,$apasswd) eq $apasswd))) {
      my $cookie=CGI::Cookie->new('-name'=>'AUTH','-value'=>"$user:$apasswd", '-expires'=>'+10y');
      $cookieinfo.="$cookie\n";
      $authenticated=1;
    } else {
      $authenticated=0;
      $cookieerror="Failed password check: ".crypt($pass,$apasswd)." $apasswd\n";
    }
  } else {
    $authenticated=0;
    $cookieerror="Failed validity check: $user $pass $auser $apasswd\n";
  }
  if (!$authenticated) {
    my $cookie=CGI::Cookie->new('-name'=>'AUTH','-value'=>':','-expires'=>'-1y');
    $cookieinfo.="$cookie\n";
  }
  return $cookieinfo;
}

sub print_login_form {
  my $script=&MyBaseUrl;
  print <<ENDFORM;
<div class="loginform">
<h3>Admin</h3>
<form method=POST action="$script">
<table>
<tr><td>Username:</td><td> <INPUT type=text size="10" name=username maxlength=256 value=""></td></tr>
<tr><td>Password:</td><td> <INPUT type=password size="10" name=password maxlength=256 value=""></td></tr>
</table>
<INPUT type=submit name="command" VALUE="Login"><br>
</form>
</div>
ENDFORM
}
